from datetime import datetime

from Products.Five import BrowserView
from Products.Five.browser.pagetemplatefile import ZopeTwoPageTemplateFile

from Products.SilvaStatic.interfaces import TransportError

class StaticView(BrowserView):
    template = ZopeTwoPageTemplateFile('static.pt')

    def __call__(self):
        self.status = ''
        self.error = ''
        self.update()
        return self.template()

    def update(self):
        if not self.request.form.has_key('SUBMIT'):
            return
        try:
            self.context.get_publication().service_static.staticize()
        except TransportError, e:
            self.error = '%s Cannot export. Reason: %s' % (
                self.datetimeStamp(), str(e))
        else:
            self.status = "%s Finished exporting the site." % self.datetimeStamp()
        
    def datetimeStamp(self):
        dt = datetime.now()
        return dt.strftime('%Y-%M-%d %H:%M:%S')

    def hasService(self):
        publication = self.context.get_publication().aq_inner
        return hasattr(publication.aq_base, 'service_static')

