import tempfile
import os
import shutil
from zope.interface import implements
from interfaces import IHarvester

class Harvester(object):
    implements(IHarvester)
    
    def __init__(self, url):
        # URL has to end with a /
        if not url.endswith('/'):
            url = url + '/'
        self.url = url        
        self.directory = tempfile.mkdtemp()

    def harvest(self):
        """Harvest a site at URL to a directory.
        """
        command = self.getCommand()
        os.system(command)

    def getCommand(self):
        """Return the command used to harvest.
        """
        raise NotImplementedError
    
    def close(self):
        """This cleans up directory sources associated with it.
        """
        shutil.rmtree(self.directory, ignore_errors=True)
        self.directory = None

    def getDirectory(self):
        """Returns the path to the directory holding the harvested content.
        """
        return self.directory
