from zope.interface import Interface

class IHarvester(Interface):
    def harvest():
        """Harvest a site to directory.
        """

    def close():
        """Does any cleanup necessary of harvested data.
        """

    def getDirectory():
        """Get the directory with the harvested information.
        """

class ITransport(Interface):
    def upload(directory):
        """Upload local files in directory to server.

        Also should delete any file on server that don't exist
        in the uploaded directory.

        Can raise TransportError with error string in strerror.
        """

    def close():
        """Close transport connection.

        After closing, no new files should be transported.
        """
        
class TransportError(Exception):
    pass
